#!/usr/bin/perl
########################## Body of Code ######################################
# copyright @ Dr. Min at YSU
# the number of argument must be 5.

if ($#ARGV != 4)
{
	print header;
	print start_html;
	print "\n";
	print "Usage: Annotator.pl  BlastOutputFile seqFastaFile aceFile lucy.info OutputFile\n";
	print "\n";
	print "Input:\n";
	print "		BlastOutputFile - BLAST output\n";
	print "		seqFastaFile - sequences in FASTA format used for BLAST\n";
	print "		aceFile (optional) - a file from PHRAP or CAP containing assembly data\n";
	print "		lucy.info (optional) - a file containing the low quality sequence length trimmed by LUCY\n";
	print "Output:\n";
	print "		targetOutputFile - target output with annotation\n";
	print "Warning: for optional files, file names must be inputed, empty files could be used!\n\n";
	print "\n";
	print end_html;
	exit;
}

########### Parameters #########
$eValue = 1;
$query = "" ;  #query sequece: contig number or clone number
$hitStatus = 0; # default as no hit
$hitInfo ="";  #the first hit infor
$frame =""; #used for translation
$queryStartPos = 0;
$queryEndPos = 0;
$sbjctStartPos = 0;
$queryStartLetter ="";
$sbjctStartLetter ="";
$head = 0; #false
$hit = 0;#false
$firstHit = 0; #false;
@fullLengthArray = ();#including full-lenght, short-full-length, possible-full-length
@partialArray = ();
@ambiguousArray =();

@NRlistArray = (); # to store the non-redundant list including no-hit singleton and contigs and full-lenth singleton and contigs
                   # ambugous sequences will not be included,  but will be manually examined if it is a full-lenth, it then will be added manually.
                   # non-full-length will not be included.


@partialList = ();
@ambiguousList = (); #for ambiguous list which will be used for retrieve ambiguous sequence
@allHitList = (); # for retrieve all hit sequences
$result = "";
$proteinName = "";
$fullySeqCount = 0;
$sbjctLength = 0;
$queryLength = 0;
$unknown_num = 0;
$signature = '';
#########################################

$BlastOutputFile = $ARGV[0];
$blastSize = -s $BlastOutputFile;
if ($blastSize == 0)
{
	exit;
}
$dnaFile = $ARGV[1];
$AceFile = $ARGV[2];               
$goodRegionFile = $ARGV[3];
$TargetOutputFile = $ARGV[4];

@seqArray = ();
#############
$midLine = 0; #the line below the "Query:" to show identity and similarity
############parameters used to analyze the blast e-value to divide the sequences with hits into
# several bin: (1) e-value <= 1e-30
#              (2) 1e-30 < e-value <= 1e-10
#              (3) 1e-10 < e-value <= 1e-5
#              (4) 1e-5 < e-value <= 0.1
#              (5) e>0.1
###################################################
$expect = 1;
$case1count = 0;
$case2count = 0;
$case3count = 0;
$caseAcount = 0;
$caseBcount = 0;

$case100count = 0;
$case50count = 0;
$case30count = 0;
$case10count = 0;
$case5count = 0;

###################################################
@BlastContent = <BLASTOUTPUTFILE>;
$position1 = 0; # blank space
$position2 = 0; # delimiter position including ", (, ["
$noHitCount = 0;
$queryCount = 0;
@noHit = ();
open (INPUT, $dnaFile);# || die ("Cannot open file $dnaFile\n\n");
$seqFlag =0; #to indicate the line is header or seqs, used for seq in multiple lines
$value ='';
$key = '';
$count =0; #to indicate the first ">"
$id = ''; # to change lucy.seq.contig# as contig#
while (<INPUT>)
{
	$line = $_; #$_, default input variable
	chomp ($line);$line =~ s/[\n\f\r]//;
	if ($line =~ /^>/)
	{
		$count++;
		if ($count >1)
		{
			$value =~ s/\s//g;
			$seqH{$key} = $value;
			# print $key."\n".$value."\n";

			$value ='';
			$key ='';
		}
		$seqFlag = 1;
		@tmpA = split(/ /, $line);
		$key = substr($tmpA[0], 1);
	}
	else
	{
		if ($seqFlag ==1)
		{
			$value .= $line;
		}
	}
}
$value =~ s/\s//g;
$seqH{$key} = $value;
close (INPUT);

open (GOODREGIONINFO, $goodRegionFile); # || die ("Cannot open file $goodRegionFile\n\n");
@goodRegionContent = <GOODREGIONINFO>;
close GOODREGIONINFO;

open (ACEFILE, $AceFile); # || die ("Cannot open file $AceFile\n\n");
@aceContent = <ACEFILE>;
close (ACEFILE);

$originalFrame = 0; # this value will be used to check the original frame value since negative value will be changed positive for $frame

open (BLASTOUTPUTFILE, $BlastOutputFile); # || die ("Cannot open file $BlastOutputFile\n\n");
$offSet = tell(BLASTOUTPUTFILE);

$summaryStart = 0;
$hFlag = 0;  # to assume 'hypothetical protein' flag is OFF.
@qsA = (); #array to store queries with a hit and subject id (all);
@sA =(); #array to store subject ids which will be used for GO annotation purpose
$sCount = 0;
while ($record = get_next_record(BLASTOUTPUTFILE))
{#foreachloop #1
	$summaryStart = 0;
	@recordA = split(/\n/, $record);
	$sCount =0;
	$sbjCount = 0;
	$hFlag = 0;
	$noHypNum = 0;
	$symCount = 0;
	$yFlag = 0; # the flag to show there is one non-hypothetical protein
	foreach $BlastContent (@recordA) #foreach start
	{#foreachloop #1
	chomp ($BlastContent);$BlastContent =~ s/[\n\f\r]//;
	@array1 = split (" ", $BlastContent);
	if ($array1[0] eq   "Query=")
	{
		$query = $array1[1];
                $queryCount++;
		$id = $query;
		#print $queryCount."\n";
		if ($query !~ /Contig/)
		{
			$signature = substr($query, 0, 4);
		}

		if ($id =~ /lucy\.seq\.Contig/)
		{
			@t = split (/\./, $id);
			$id = $t[2];
		}
		next;
	}

	if ($summaryStart ==1)
        {
                $line = lc ($BlastContent);
                if ($line =~ /\w/)
		{
			$sbjCount++;
			if (($line =~ /hypothetical/) || ($line =~ /unnamed/) || ($line =~ /predicted/) || ($line =~ /unknown/))
                	{
				$hFlag = 1;
				$sCount++;
                	}
			else   #newly added in Version5
			{
				if ($yFlag == 0)
				{
					$noHypNum = $sbjCount;
					$yFlag = 1;
				}
			}
		}
        }

	if ($BlastContent =~ /No hits found/)
	{
	        push (@NRlistArray, $query."\n"); #store the no hit query in the NR-list
                push (@noHit, $query."\n");
		$noHitCount++;
		$query = "";
                next;
	}

      	elsif ($BlastContent =~ /^Sequences/)
	{
		$hit = 1; # there is a hit at least
		$summaryStart = 1;
	}

       elsif ($BlastContent =~ /^>/)
       {
		$summaryStart = 0;
		$symCount++;
		if ($hit ==1)
	 	{
             		$firstHit = 1;
             		$hitInfo = $BlastContent;
             		$position1 = index ($BlastContent, " ");
			$proteinName = substr ($BlastContent, $position1+1);
           		@spA = split(/\|/, $BlastContent);
			$sp = $spA[1];
			$line = lc($BlastContent);
			if (($line =~ /hypothetical/) || ($line =~ /unnamed/) || ($line =~ /predicted/) || ($line =~ /unknown/))
			{
				$firstHit = 0;
			}
						
			############ newly added in version5 ##########
			if ($hFlag == 1)
			{ 
				if ($sbjCount == $sCount)
				{
					$firstHit = 1;
				}
			}
			else
			{	
				if ($sbjCount == 1)
				{
					$firstHit = 1;
				}
			}
			if ($symCount == $noHypNum)
			{
				$firstHit = 1;
			}
			$LengthFlag = 0;
	 	}
        }

        else
        { # else - OUT1
	    if ($hit ==1 && $firstHit ==1)
	    {# if$hit and $firstHit both true)
	    	if ($BlastContent =~ /Identities/)
	     	{
			$hitInfo = $hitInfo.$BlastContent;
			if ($proteinName =~ /gi\|/)
             		{
            			$position2 = index ($proteinName, "|");
				$proteinName = substr ($proteinName, 0, $position2 -2);
	     			$position1 = 0;
             			$position2 = 0;
             		}

	       		if (($proteinName =~ /^probable/) || ($proteinName =~ /^possible/i) || ($proteinName =~ /^Probable/) || ($proteinName =~ /^PROBABLE/) || ($proteinName =~ /^Putative/) || ($proteinName =~ /^putative/) || ($proteinName =~ /^PUTATIVE/))
	       		{
				$pos = index($proteinName, " ");
				$proteinName = substr ($proteinName, $pos+1);
	       		}
	      		if (($proteinName =~ /similar to/) || ($proteinName =~ /Similar to/) || ($proteinName =~ /SIMILAR TO/) || ($proteinName =~ /[Hh]omologous to/) || ($proteinName =~ /HOMOLOGUE TO/i) || ($proteinName =~ /Related to/) || ($proteinName =~ /related to/))
	      		{
				$pos2 = index ($proteinName, "to");
                		$proteinName = substr ($proteinName, $pos2 + 3);
 	      		}

			if ($proteinName =~ /\[/)
             		{
            	 		$pos2 = index ($proteinName, "[");
		 		$proteinName = substr ($proteinName, 0, $pos2-1);
             		}

			@tProtein = split(/\s+/, $proteinName);
	     		$proteinName = '';
			foreach $w (@tProtein)
	     		{
				if ($w =~ /\w/)
				{
					if ($proteinName eq '')
					{
						$proteinName = $w;
					}
					else
					{
						$proteinName =$proteinName." ".$w;
	     				}
				}
	     		}
		}
		#added to count the e-values
		elsif (($BlastContent =~ /Length/) && ($BlastContent =~ /=/))
		{
			$hitInfo = $hitInfo.$BlastContent;
			@LArray = split(/=/, $BlastContent);
			$sbjctLength = $LArray[1]*1;
			$LengthFlag = 1;
		}
		elsif ($BlastContent =~ /Expect/)
		{
                        $hitInfo = $hitInfo.$BlastContent;
			@expectLine = split(/,/, $BlastContent);
			$eString = $expectLine[1];
			@subString = split (/ /, $eString);
			$expect = $subString[3];
			$expect = lc ($expect);
			$Eint++;
#################
			if ($expect > $eValue)
			{
				$hit = 0;
				$firstHit = 0;
			}
			if ($expect <= 1e-100)
			{
				$category = '';
				$case100count++;
			}
			elsif ($expect <= 1e-50)
			{
				$category = "Homologous to ";
				$case50count++;
			}
			elsif ($expect <= 1e-30)
			{
				$category = 'Highly similar to ';
				$case30count++;
			}
			elsif ($expect <= 1e-10)
			{
				$category = "Similar to ";
				$case10count++;
			}
			elsif ($expect <= 1e-5)
			{
	   			$case5count++;
				$category = "Weakly similar to ";
	 		}
			elsif ($expect <= 0.1)
        		{
        			$caseAcount++; $category = "Very weakly similar to ";
			}
        		else
        		{
        			$caseBcount++;$category = "Extremely weakly similar to ";
        		}
			
#####################		
		}

		elsif ($BlastContent =~ /Frame/)
	        {
	        	$frame = $array1[2];
                        $hitInfo = $hitInfo.$BlastContent;
			@tmpHitInfor = split(/\s+/, $hitInfo);
	     		$hitInfo = '';
	     		foreach $t (@tmpHitInfor)
	     		{
				if ($t =~ /\w/)
				{
					if ($hitInfo eq '')
					{
						$hitInfo = $t;
					}
					else
					{
						$hitInfo =$hitInfo." ".$t;
	     				}
				}
			}

          		$originalFrame = $frame;
		        next;
                }
                elsif ($BlastContent=~ /Query:/)
		{
                	$queryStartPos = $array1[1];
	     		$queryEndPos = $array1[3];
			$queryStartLetter = substr($array1[2], 0, 1);
        		$midLine = 1; # set it to true
                }

                elsif ($BlastContent=~ /Sbjct:/) #elsif -1
                {
                    $hit = 0;
                    $firstHit = 0;
		    $proteinName = $category.$proteinName;
		    push (@allHitList, $query."\n");
	###############################################################################
                    $sbjctStartPos = $array1[1];
                    $sbjctStartLetter = substr($array1[2], 0, 1);
		    $sbjctEndPos = $array1[3];
                    $sequence = $seqH{$query};
		#############################################
			$wholeLength = length ($sequence);  #to obtain the length of the whole sequence for frame with negative value
			$sequence = uc($sequence);
			#push (@seqArray, ">".$query."\n".$sequence."\n");
			$originalFrame = $frame;
			$lengthFlag = 0;
	#################
 			if ($frame == 0)
                    	{
 				 $result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."N/A\t"."N/A"."\t"."N/A"."\n";
                                 push (@fullLengthArray, $result);
				$result = "";
                                next;
			}
#########################	

			if ($frame > 0)
			{
				if ((($sbjctLength - $sbjctStartPos) - ($wholeLength - $queryStartPos)/3) > 0)
				{
					$lengthFlag = 1;
				}
			}

			if ($frame < 0)
                	{
				$revComSeq = reverse $sequence;
                		$revComSeq =~ tr/ACGTacgt/TGCAtgca/;
                		$sequence = $revComSeq;
				$queryStartPos = $wholeLength - $queryStartPos +1;
				$queryEnd = $queryEndPos;
				$queryEndPos = $wholeLength - $queryEndPos +1;
   				$frame = $frame * (-1);
				if ((($sbjctLength - $sbjctEndPos) - $queryEnd/3) > 0)
				{
					$lengthFlag = 1;
				}
   			}
			$subSeq = substr($sequence, $frame - 1, $queryEndPos);
                	$length = length ($subSeq);
              		@base = split(//, $subSeq);
			$index = 0;
                	$stopCodonFlag = 0; # no stop codon
 ############ newly added for searching stop codon after start codon, to examine the sequence is fully sequenced or not, containing 3' stop codon or not.
       			$subSeq2 = substr ($sequence, $queryEndPos); #to avoid the first part that may have a stop codon
			$length2 = length ($subSeq2);
			@base2 = split(//, $subSeq2);
			$stopAfterStart = 0;
			for ($index2 = 0; $index2 <= $length2 -3; $index2++)
                	{
                		if (($base2[$index2] eq 'T') && ($base2[$index2 +1] eq 'A') && ($base2[$index2 +2] eq 'A' ))
                        	{
                        		$stopAfterStart = 1;
                                	last;
                       		}
	 			elsif (($base2[$index2] eq 'T') && ($base2[$index2 + 1] eq 'A') && ($base2[$index2 +2] eq 'G'))
                        	{
                        		$stopAfterStart = 1;
                                	last;
                     		}
                        	elsif (($base2[$index2] eq 'T') && ($base2[$index2 +1] eq 'G') && ($base2[$index2 +2] eq 'A'))
                        	{
		   			$stopAfterStart = 1;
                                	last;
       				}
				else
                        	{
                        		$index2 = $index2 + 2;
                                	$stopAfterStart = 0;
                        	}
   			}
			$direction = "";
			if ($frame == 0)
			{
				$info = "N/A";
			}
			if ($originalFrame < 0)
			{
				$direction = "antisense ";
	        	}
			elsif ($originalFrame > 0)
			{
				$direction = "sense ";
			}
			if ($originalFrame <0)
			{
				$info = $direction."complete";
			}
			elsif ($originalFrame >0)
			{
				if ($lengthFlag == 0)
				{
					$info = $direction."complete";
				}
				else
        	        	{
                			$info = $direction."partial";
               			}
			}
			#############################
                	for ($index = 0; $index <= $length-3; $index++)
                	{
				if(($base[$index] eq 'A') && ($base[$index + 1] eq 'T') && ($base[$index + 2] eq 'G'))
                		{#if atg
              				$full = 1;
                       			$hit = 0;
                       			$firstHit = 0;
					$atgPos = $index + $frame;
					$atgEnd = $atgPos + 2;
					if ($stopCodonFlag == 1)
                        		{
						if ($stopAfterStart ==1 && $lengthFlag == 0)
                                   		{
                                   			$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Full-length"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
							$fullySeqCount++;
							$stopAfterStart = 0;
                                   		}
                                   		else
                                   		{
                                   			$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Full-length\t".$atgPos."_".$atgEnd."\t".$info."\n";
                                   		}
                                   		push (@fullLengthArray, $result);
                                   		push (@NRlistArray, $query."\n");
                                   		$result = "";
				   		$stopAfterStart = 0;
				 	}
                                 	else #stop codon before start codon is false
                                 	{
               					$shorter = $sbjctStartPos - ($queryStartPos - $index - $frame)/3;
						$seqID = "";
                                    		if ($shorter < 10)
                                    		{
                                        		 $result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Full-length"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
                                        		push (@fullLengthArray, $result);
                                        		push (@NRlistArray, $query."\n");
                                        		$result ="";
                                        		if ($stopAfterStart == 1)
                                        		{
				  				$fullySeqCount++;
                                        		}
				    		}
						elsif (($shorter >= 10) && ($shorter <100))
                                    		{
							$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Short ($shorter) full-length"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
                                       			push (@sflArray, $result);
                                        		push (@NRlistArray, $query."\n");
                                         		$result = "";
							if ($stopAfterStart == 1)
							{
					 			$fullySeqCount++;
                                        		}
			            		}

				################### newly added for Version3 for checking possible-full-length ##
						else
				 		{#start else-A
							$partialFlag = 0;
							if ($originalFrame < 0)
							{
								$partialFlag = 2;
							}
							else
							{#??
								if ($query =~ /Contig/) # for contig
								{
									foreach $line (@aceContent)
									{
										if ($line =~ /$query/)
										{
											$flagTmp = 1;
						   					next;
					        				}
										elsif ($line =~ /$signature/)
										{
											if ($flagTmp ==1)
						   					{
												@arrayTmp = split (/ /, $line);
												$seqID = $arrayTmp[1];
												last;
						   					}
										}
										else
										{
						 					next;
                                                				}
   					   				}# end foreach
					 			}
								else
								{
									$seqID = $query;
								}
								$trimLength = 0;
								foreach $seqLine (@goodRegionContent)
								{
					   				if ($seqLine =~ /$seqID/)
					   				{
										@arrayTmp3 = split (/\t/, $seqLine);
										$trimLength = $arrayTmp3[2];
					        				last;
					   				}
					   			}#end of foreach
							#compare the length
								$d = $trimLength - 60; # I suppose that the spliced sequence from vector+adaptor is 60 nt
							# the exact number needs to be checked for each library
								if ($d <= 0)
								{
									$partialFlag = 1; #set to true
                     						}
								else
                                        			{
									if ((($d + $queryStartPos)/3 - $sbjctStartPos) > 0)
									{
										$partialFlag = 0; # possible full length
                                                			}
                                                			else
									{ $partialFlag = 1;}
                                        			}
        		         			} # end ??
        						if ($partialFlag ==0)
                                        		{
					  			$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Possible full-length"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
					  			push (@pflArray, $result);
					  			$possibleCount++;
								push (@NRlistArray, $query."\n");
					  			$result = "";
				          			if ($stopAfterStart == 1)
					  			{
									$fullySeqCount++;
				          			}
							}
							elsif ($partialFlag == 1)
                                   			{
								$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Partial"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
								push (@partialArray, $result);
                               	    	       			push (@partialList, $query."\n");
								$result = "";
                                        		}
							else
							{
								$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."3'-sequenced partial"."\t".$atgPos."_".$atgEnd."\t".$info."\n";
						  		push (@p3Array, $result);
                               	    				push (@partialList, $query."\n");
								$unknown_num++;
								$result = "";
					  		}
                                 		} #end else-A
                       			}# end of else $stop-codon-before start codon = false
                                	$proteinName = "";
                                	$query = "";
                                	$midLine = 0;
                                	$hitInfo = "";
                                	$stopAfterStart = 0;
                                	last;
				}#end of if atg
	 			#stop codon
				elsif (($base[$index] eq 'T') && ($base[$index +1] eq 'A') && ($base[$index +2] eq 'A' ))
                        	{
                        		$stopCodonFlag = 1;
                        		$index = $index + 2;
                     		}
				elsif (($base[$index] eq 'T') && ($base[$index + 1] eq 'A') && ($base[$index +2] eq 'G'))
                        	{
                        		$stopCodonFlag = 1;
                       			$index = $index + 2;
                       		}
                        	elsif (($base[$index] eq 'T') && ($base[$index +1] eq 'G') && ($base[$index +2] eq 'A'))
                        	{
		   			$stopCodonFlag = 1;
                        		$index = $index +2;
                       		}
			#other codons
				else
                        	{
                        		$index = $index + 2;
                       			$full = 0;
                        	}
			}#end for loop

			if ($full == 0)
                	{
				$seqID = "";
				if ($stopCodonFlag ==1 && $originalFrame > 0)
                		{
                        		$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Ambiguous\t"."NO\t".$info."\n";
                                	push (@ambiguousArray, $result);
                                	push (@NRlistArray, $query."\n");
					push (@ambiguousList, $query."\n");
                                	$result = "";
					$proteinName = "";
                		}
                        	else
                        	{# else -?
           				$partialFlag = 0;
					if ($originalFrame < 0)
					{
						$partialFlag = 2;
					}
                        		else
                                	{#!
						if ($query =~ /Contig/) # for contig
						{
							foreach $line (@aceContent)
							{
								if ($line =~ /$query/)
								{
									$flagTmp = 1;
						   			next;
					        		}
								elsif ($line =~ /$signature/)
								{
						   			if ($flagTmp ==1)
						   			{
										@arrayTmp = split (/ /, $line);
										$seqID = $arrayTmp[1];
										last;
						   			}
                                                		}
								  else
					        		{ next;
                                                        	}
					      		}#foreach
						} #end if for contig
						else
						{
							$seqID = $query;
						}
						$trimLength = 0;
						foreach $seqLine (@goodRegionContent)
						{
							if ($seqLine =~ /$seqID/)
							{
								@arrayTmp3 = split (/\t/, $seqLine);
								$trimLength = $arrayTmp3[2];
					        		last;
					   		}
						}#end of foreach
						#compare the length
						$d = $trimLength - 60; # I suppose that the spliced sequence from vector+adaptor is 60 nt
						if ($d <= 0)
						{
							$partialFlag = 1; #set to true
                     				}
						else
                                        	{
							if ((($d + $queryStartPos)/3 - $sbjctStartPos) > 0)
							{
								$partialFlag = 0; # possible full length
                                                	}
                                                	else
							{ $partialFlag = 1;}
                                        	}
        				} # !
        				if ($partialFlag ==0)
					{
						$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."POSSIBLE FULL-LENGTH"."\t"."NO"."\t".$info."\t".$hitInfo."\n";
						push (@pflArray, $result);
						push (@NRlistArray, $query."\n");
                              			$possibleCount++;
                                     		$result ="";
					}
					elsif ($partialFlag ==1)
                                	{
						$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."Partial"."\t"."NO\t".$info."\n";
						push (@partialArray, $result);
                               	        	push (@partialList, $query."\n");
						$result = "";
                        		}
					else
					{
						$result = $id."\t".$sp."\t".$expect."\t".$proteinName."\t"."3'-sequenced partial"."\t"."NO\t".$info."\n";
						push (@p3Array, $result);
                               			push (@partialList, $query."\n");
						$unknown_num++;
						$result = "";
					}
               			}     # end else-?
	       ############################ end of newly revised in Version3.0 ##################
               			$hit = 0;
                       		$firstHit = 0;
                        	$query = "";
                        	$midLine = 0;
                        	$hitInfo = "";
                        	$proteinName = "";
				$info = '';
              		} #end if full==0
		} #end of elsif -1

     		else # hit and firstHit are both true
     		{
     			if ($midLine == 0)
     			{
     				$hitInfo =$hitInfo.$BlastContent;
        		}
			if ($LengthFlag == 0)
	          	{
       		      		$proteinName .= $BlastContent;
			}
		}
	} # end of #both $hit and $firstHit are true
 	else
   	{
     		$midLine = 0;next;
	}
    }#end of OUT-1
  } #end foreach
  $offSet = tell(BLASTOUTPUTFILE);
}#end of while loop

close (BLASTOUTPUTFILE);
#output
open (OUT, ">$TargetOutputFile");
print "\n";
print OUT "SUMMARY OF THE ANNOTATOR REPORT:\n";
print OUT "total number of sequences\t".$queryCount."\n";
print OUT "number of no hit\t".$noHitCount."\n";
$hitNum = $queryCount - $noHitCount;
print OUT "number of sequences with hit\t".$hitNum."\n";
print OUT "full-length sequences\t".@fullLengthArray."\n";
print OUT "short full-length sequences\t".@sflArray."\n";
print OUT "possible full-length sequences\t".@pflArray."\n";
print OUT "ambiguous sequences\t".@ambiguousArray."\n";
print OUT "partial sequences (5'-sequenced partial)\t".@partialArray."\n";
print OUT "3'-sequenced partial sequences\t".@p3Array."\n";
print OUT "full-length & ORF completely sequenced sequences\t".$fullySeqCount."\n\n";
print OUT "number of hits with e-values <= 1e-100\t".$case100count."\n";
print OUT "number of hits with e-values <= 1e-50 and > 1e-100\t".$case50count."\n";
print OUT "number of hits with e-values <= 1e-30 and > 1e-50\t".$case30count."\n";
print OUT "number of hits with e-values <= 1e-10 and > 1e-30\t".$case10count."\n";
print OUT "number of hits with e-values <= 1e-5 and > 1e-10\t".$case5count."\n";
print OUT "number of hits with e-values <= 0.1 and > 1e-5\t".$caseAcount."\n";
print OUT "number of hits with e-values > 0.1\t".$caseBcount."\n\n";

print OUT (@fullLengthArray);
print OUT (@sflArray);
print OUT (@pflArray);
print OUT (@partialArray);
print OUT (@p3Array);
print OUT (@ambiguousArray);
close (OUT);

open (target, $TargetOutputFile) || die ("Cannot open file $TargetOutputFile\n\n");
@Content = <target>;
close target;

exit;

################
sub get_next_record
{
	my($fh) = @_;
	use strict;
	my($offSet);
	my($record);
	my($seperator) = $/;
	$/ = "BLAST";
	$record =<$fh>;
	$/ =$seperator;
	return $record;
}



